#include "mbed.h"
#include "rtos.h"
#include "SDFileSystem.h"
#include "wave_player.h"
#include <string>

SDFileSystem sd(p5, p6, p7, p8, "sd");  // the pinout on the mbed Cool Components workshop board
Serial pc (USBTX,USBRX);
DigitalOut led(LED1);
AnalogOut DACout(p18); // speaker
wave_player waver(&DACout);
//#define MAXLINE 100
//char myline [MAXLINE];
//int i, inch ;
string dir;
//string song = "africa-toto";
string song;
bool play;
Mutex speaker_lock;



void speaker_thread(void const* args)
{
    while(1) {
        // check helper function for new song in GUI
        // grab file here and put together string
        // string song_title = "/sd/" + "" + ".wav";
        
        
        if(play == true)
        {
            //speaker_lock.lock();
            FILE *wave_file;
            dir = "/sd/" + song + ".wav";
            wave_file=fopen(dir.c_str(),"r");
            waver.play(wave_file);
            fclose(wave_file);
            //speaker_lock.unlock();
        }
        Thread::wait(1000);
    }
}












int main()
{
    
    char c;
    Thread speaker(speaker_thread);
    //led = 1;
    while(1) {
        wait(0.2);
        
        while(!pc.readable()) {
            Thread::wait(1);
        }
        if (pc.getc() == '!') {
            c = pc.getc();
            switch(c) {
                case '1':
                    song = "africa-toto";
                    //led = 1;
                    break;
                case '2':
                    song = "around_the_world-atc";
                    break;
                case '3':
                    song = "beautiful_life-ace_of_base";
                    break;
                case '4':
                    song = "dont_speak-no_doubt";
                    break;
                case '5':
                    song = "my-love";
                    break;
                case '6':
                    song = "Song1_test";
                    //speaker.terminate();
                    break;
                case 'P':
                    // wave_player plays
                    play = true;
                    break;
                case 'S':
                    // wave_player stops
                    play = false;
                    //led!=led;
                    //speaker.terminate();
                    break;
                default:
                    break;
            }
            
            if(play==true){led=1;}
            else{led=0;}
        }
        Thread::wait(200);
    }
}







//============================================================================//
/*
int main() {
    printf("\n\r= = = = = = = = = =");
    printf("\n\rHello World!\n\r");
    mkdir("/sd/mydir", 0777); // Test that previous run had created permanent folder
    // write
    FILE *fp = fopen("/sd/mydir/sdtest.txt", "w"); // Commenting out, in a later run, from here ..
    if(fp == NULL) {
        error("Could not open file for write\n");
    }
    fprintf(fp, "Hello from SD Card World!");
    fclose(fp);
    printf("Created file in sdcard\n\r"); //.. to here shows file really is permanent .. .. since it still reads correctly.
    // read
    printf("Reading file\n");
    string inputString;
    FILE *fp1 = fopen("/sd/mydir/sdtest.txt", "r");
    if (fp1 == NULL) {
       printf("Error Open \n");
    } else {
        printf("\r");
        while(fscanf(fp1, "%s", inputString)!=EOF) {
            printf("%s ", inputString.c_str());
        }
    }
    fclose(fp1);                              // close the file
    printf("\n\rFinished reading the file");
    printf("\n\r= = = = = = = = = =");

    return 0;
}
*/